"use strict";require("core-js/modules/es.array.iterator");Object.defineProperty(exports,"__esModule",{value:true});exports.cartesianIterate=exports.cartesianArray=void 0;var _moize=_interopRequireDefault(require("moize"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}



const cartesianArray=function(...arrays){
if(arrays.length===0){
return[];
}

arrays.forEach(validateArray);

const loopFunc=getLoopFunc(arrays.length,false);
const result=[];
loopFunc(arrays,result);
return result;
};exports.cartesianArray=cartesianArray;




const cartesianIterate=function*(...arrays){
if(arrays.length===0){
return;
}

arrays.forEach(validateArray);

const loopFunc=getLoopFunc(arrays.length,true);
yield*loopFunc(arrays);
};exports.cartesianIterate=cartesianIterate;

const validateArray=function(array){
if(!Array.isArray(array)){
throw new TypeError(`Argument must be an array: ${array}`);
}
};











const mGetLoopFunc=function(length,iterable){
const indexes=Array.from({length},getIndex);
const repeatA=repeat.bind(null,indexes);

const start=repeatA(
index=>`for (const value${index} of arrays[${index}]) {`);

const middle=repeatA(index=>`value${index}`,", ");
const end=repeatA(()=>"}");

if(iterable){
return new GeneratorFunction("arrays",`${start} yield [${middle}] ${end}`);
}


return new Function(
"arrays",
"result",
`${start}\nresult.push([${middle}])\n${end}`);

};

const getLoopFunc=(0,_moize.default)(mGetLoopFunc);

const getIndex=function(value,index){
return String(index);
};

const repeat=function(indexes,mapper,separator="\n"){
return indexes.map(mapper).join(separator);
};


const GeneratorFunction=cartesianIterate.constructor;
//# sourceMappingURL=main.js.map